#[doc = "Register `MSK6` reader"]
pub struct R(crate::R<MSK6_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MSK6_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MSK6_SPEC>> for R {
    fn from(reader: crate::R<MSK6_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MSK6` writer"]
pub struct W(crate::W<MSK6_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MSK6_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MSK6_SPEC>> for W {
    fn from(writer: crate::W<MSK6_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `MSK_LS` reader - Interrupt Mask Register"]
pub struct MSK_LS_R(crate::FieldReader<u8, u8>);
impl MSK_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        MSK_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for MSK_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `MSK_LS` writer - Interrupt Mask Register"]
pub struct MSK_LS_W<'a> {
    w: &'a mut W,
}
impl<'a> MSK_LS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x7f) | (value as u16 & 0x7f);
        self.w
    }
}
#[doc = "Field `MSK_MS` reader - Interrupt Mask Register"]
pub struct MSK_MS_R(crate::FieldReader<u8, u8>);
impl MSK_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        MSK_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for MSK_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `MSK_MS` writer - Interrupt Mask Register"]
pub struct MSK_MS_W<'a> {
    w: &'a mut W,
}
impl<'a> MSK_MS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x7f << 8)) | ((value as u16 & 0x7f) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:6 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk_ls(&self) -> MSK_LS_R {
        MSK_LS_R::new((self.bits & 0x7f) as u8)
    }
    #[doc = "Bits 8:14 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk_ms(&self) -> MSK_MS_R {
        MSK_MS_R::new(((self.bits >> 8) & 0x7f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:6 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk_ls(&mut self) -> MSK_LS_W {
        MSK_LS_W { w: self }
    }
    #[doc = "Bits 8:14 - Interrupt Mask Register"]
    #[inline(always)]
    pub fn msk_ms(&mut self) -> MSK_MS_W {
        MSK_MS_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Mask\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [msk6](index.html) module"]
pub struct MSK6_SPEC;
impl crate::RegisterSpec for MSK6_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [msk6::R](R) reader structure"]
impl crate::Readable for MSK6_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [msk6::W](W) writer structure"]
impl crate::Writable for MSK6_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MSK6 to value 0"]
impl crate::Resettable for MSK6_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
